<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?>
<?php
class plgAcymailingDocman extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'docman');
			$this->params = new JParameter( $plugin->params );
		}
	}
	function acymailing_getPluginType() {
		$app = JFactory::getApplication();
	 	if($this->params->get('frontendaccess') == 'none' AND !$app->isAdmin()) return;
	 	$onePlugin = new stdClass();
	 	$onePlugin->name = 'DOCman';
	 	$onePlugin->function = 'acymailingdocman_show';
	 	$onePlugin->help = 'plugin-docman';
	 	return $onePlugin;
	 }
	 function acymailingdocman_show(){

	 	$config = acymailing_config();
		if($config->get('version') < '4.0.0'){
			acymailing_display('Please download and install the latest AcyMailing version otherwise this plugin will NOT work','error');
			return;
		}

		$lang = JFactory::getLanguage();
		$lang->load('com_docman',JPATH_SITE);
		$app = JFactory::getApplication();

		$pageInfo = new stdClass();
		$pageInfo->filter = new stdClass();
		$pageInfo->filter->order = new stdClass();
		$pageInfo->limit = new stdClass();
		$pageInfo->elements = new stdClass();

		$paramBase = ACYMAILING_COMPONENT.'.docman';

		$pageInfo->filter->order->value = $app->getUserStateFromRequest( $paramBase.".filter_order", 'filter_order',	'a.id','cmd' );
		$pageInfo->filter->order->dir	= $app->getUserStateFromRequest( $paramBase.".filter_order_Dir", 'filter_order_Dir',	'desc',	'word' );
		if(strtolower($pageInfo->filter->order->dir) !== 'desc') $pageInfo->filter->order->dir = 'asc';
		$pageInfo->search = $app->getUserStateFromRequest( $paramBase.".search", 'search', '', 'string' );
		$pageInfo->search = JString::strtolower(trim($pageInfo->search));
		$pageInfo->filter_cat = $app->getUserStateFromRequest( $paramBase.".filter_cat", 'filter_cat','','int' );
		$pageInfo->titlelink = $app->getUserStateFromRequest( $paramBase.".titlelink", 'titlelink','|link','string' );
		$pageInfo->download = $app->getUserStateFromRequest( $paramBase.".download", 'download','|download','string' );
		$pageInfo->pict = $app->getUserStateFromRequest( $paramBase.".pict", 'pict','|pict:1','string' );
		$pageInfo->contenttype = $app->getUserStateFromRequest( $paramBase.".contenttype", 'contenttype','|type:intro','string' );
		$pageInfo->limit->value = $app->getUserStateFromRequest( $paramBase.'.list_limit', 'limit', $app->getCfg('list_limit'), 'int' );
		$pageInfo->limit->start = $app->getUserStateFromRequest( $paramBase.'.limitstart', 'limitstart', 0, 'int' );
		$pageInfo->autotitlelink = $app->getUserStateFromRequest( $paramBase.".autotitlelink", 'autotitlelink','|link','string' );
		$pageInfo->autopict = $app->getUserStateFromRequest( $paramBase.".autopict", 'autopict','|pict:1','string' );
		$pageInfo->automaxvalue = $app->getUserStateFromRequest( $paramBase.".max", 'max','20','int' );
		$pageInfo->contentfilter = $app->getUserStateFromRequest( $paramBase.".contentfilter", 'contentfilter','|filter:created','string' );
		$pageInfo->contentorder = $app->getUserStateFromRequest( $paramBase.".contentorder", 'contentorder','|order:id','string' );
		$pageInfo->autocontenttype = $app->getUserStateFromRequest( $paramBase.".autocontenttype", 'autocontenttype','|type:intro','string' );
		$pageInfo->downloadauto = $app->getUserStateFromRequest( $paramBase.".download", 'download','|download','string' );

		$db = JFactory::getDBO();

		$searchFields = array('a.id','a.dmname','b.title','c.username','a.dmfilename');

		if(!empty($pageInfo->search)){
			$searchVal = '\'%'.acymailing_getEscaped($pageInfo->search,true).'%\'';
			$filters[] = implode(" LIKE $searchVal OR ",$searchFields)." LIKE $searchVal";
		}

		if($this->params->get('displayart','all') == 'onlypub'){
			$filters[] = "a.published = 1";
		}
		else{
			$filters[] = "a.published != -2";
		}

		$query = 'SELECT a.*,b.*,c.*,a.id as DocId FROM `#__docman` AS a ';
		if(ACYMAILING_J16){
			$query .= 'JOIN #__docman_categories AS b ON a.catid = b.id ';
		}else{
			$query .= 'JOIN #__categories AS b ON a.catid = b.id ';
		}
		$query .= 'LEFT JOIN `#__users` AS c ON a.dmsubmitedby = c.id';
		if(!empty($pageInfo->filter_cat)) $filters[] = "a.catid = ".$pageInfo->filter_cat;

		if(!empty($filters)){
			$query .= ' WHERE ('.implode(') AND (',$filters).')';
		}

		if(!empty($pageInfo->filter->order->value)){
			$query .= ' ORDER BY '.$pageInfo->filter->order->value.' '.$pageInfo->filter->order->dir;
		}

		$db->setQuery($query,$pageInfo->limit->start,$pageInfo->limit->value);
		$rows = $db->loadObjectList();

		if(!empty($pageInfo->search)){
			$rows = acymailing_search($pageInfo->search,$rows);
		}

		$db->setQuery('SELECT FOUND_ROWS()');
		$pageInfo->elements->total = $db->loadResult();
		$pageInfo->elements->page = count($rows);

		jimport('joomla.html.pagination');
		$pagination = new JPagination( $pageInfo->elements->total, $pageInfo->limit->start, $pageInfo->limit->value );

		$type = JRequest::getString('type');

	?>
		<script language="javascript" type="text/javascript">
		<!--
			var selectedContents = new Array();
			function applyContent(contentid,rowClass){
				if(selectedContents[contentid]){
					window.document.getElementById('content'+contentid).className = rowClass;
					delete selectedContents[contentid];
				}else{
					window.document.getElementById('content'+contentid).className = 'selectedrow';
					selectedContents[contentid] = 'content';
				}

				updateTag();
			}

			function updateTag(){
				var tag = '';
				var otherinfo = '';
				for(var i=0; i < document.adminForm.contenttype.length; i++){
					 if (document.adminForm.contenttype[i].checked){ selectedtype = document.adminForm.contenttype[i].value; otherinfo += document.adminForm.contenttype[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.pict.length; i++){
						 if (document.adminForm.pict[i].checked){ otherinfo += document.adminForm.pict[i].value; }
					}
				}
				for(var i=0; i < document.adminForm.titlelink.length; i++){
					 if (document.adminForm.titlelink[i].checked){ otherinfo += document.adminForm.titlelink[i].value; }
				}
				for(var i=0; i < document.adminForm.download.length; i++){
					if (document.adminForm.download[i].checked){ otherinfo += document.adminForm.download[i].value; }
				}
				for(var i in selectedContents){
					if(selectedContents[i] == 'content'){
						tag = tag + '{docman:'+i+otherinfo+'}<br />';
					}
				}
				setTag(tag);
			}

			var selectedCat = new Array();
			function applyAuto(catid,rowClass){
				if(selectedCat[catid]){
					window.document.getElementById('cat'+catid).className = rowClass;
					delete selectedCat[catid];
				}else{
					window.document.getElementById('cat'+catid).className = 'selectedrow';
					selectedCat[catid] = 'selectedone';
				}

				updateTagAuto();
			}

			function updateTagAuto(){
				tag = '{autodocman:';

				for(var icat in selectedCat){
					if(selectedCat[icat] == 'selectedone'){
						tag += icat+'-';
					}
				}

				if(document.adminForm.min_article && document.adminForm.min_article.value && document.adminForm.min_article.value!=0){ tag += '|min:'+document.adminForm.min_article.value; }
				if(document.adminForm.max_article.value && document.adminForm.max_article.value!=0){ tag += '|max:'+document.adminForm.max_article.value; }
				for(var i=0; i < document.adminForm.contenttypeauto.length; i++){
					 if (document.adminForm.contenttypeauto[i].checked){ selectedtype = document.adminForm.contenttypeauto[i].value; tag += document.adminForm.contenttypeauto[i].value; }
				}
				for(var i=0; i < document.adminForm.downloadauto.length; i++){
					if (document.adminForm.downloadauto[i].checked){ tag += document.adminForm.downloadauto[i].value; }
				}
				if(selectedtype != '|type:title'){
					for(var i=0; i < document.adminForm.autopict.length; i++){
						 if (document.adminForm.autopict[i].checked){ tag += document.adminForm.autopict[i].value; }
					}
				}
				for(var i=0; i < document.adminForm.autotitlelink.length; i++){
					 if (document.adminForm.autotitlelink[i].checked){ tag += document.adminForm.autotitlelink[i].value; }
				}

				if(document.adminForm.contentorder.value){ tag += document.adminForm.contentorder.value; }
				if(document.adminForm.contentfilter && document.adminForm.contentfilter.value){ tag += document.adminForm.contentfilter.value; }

				tag += '}';

				setTag(tag);
			}
		//-->
		</script>
		<?php
		$valImages = array();
		$valImages[] = JHTML::_('select.option', "|pict:1",JText::_('JOOMEXT_YES'));
		$valImages[] = JHTML::_('select.option', "|pict:resized",JText::_('RESIZED'));
		$valImages[] = JHTML::_('select.option', "|pict:0",JText::_('JOOMEXT_NO'));

		$ordering = array();
		$ordering[] = JHTML::_('select.option', "|order:id,DESC",JText::_('ACY_ID'));
		$ordering[] = JHTML::_('select.option', "|order:dmdate_published,DESC",JText::_('CREATED_DATE'));
		$ordering[] = JHTML::_('select.option', "|order:dmlastupdateon,DESC",JText::_('MODIFIED_DATE'));
		$ordering[] = JHTML::_('select.option', "|order:dmname,ASC",JText::_('FIELD_TITLE'));
		$ordering[] = JHTML::_('select.option', "|order:rand",JText::_('ACY_RANDOM'));

		$contenttype = array();
		$contenttype[] = JHTML::_('select.option', "|type:title",JText::_('TITLE_ONLY'));
		$contenttype[] = JHTML::_('select.option', "|type:intro",JText::_('CATEGORY_VIEW'));
		$contenttype[] = JHTML::_('select.option', "|type:full",JText::_('DETAILS_VIEW'));

		$download = array();
		$download[] = JHTML::_('select.option', "|download",JText::_('JOOMEXT_YES'));
		$download[] = JHTML::_('select.option', "",JText::_('JOOMEXT_NO'));
		$tabs = acymailing_get('helper.acytabs');
		echo $tabs->startPane( 'docman_tab');
		echo $tabs->startPanel( JText::_('TAG_ELEMENTS'), 'docman_listings');
		?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('select.radiolist', $contenttype, 'contenttype' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->contenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
					<?php $titlelinkType = acymailing_get('type.titlelink'); echo $titlelinkType->display('titlelink',$pageInfo->titlelink);?>
				</td>
				 <td>
				<?php echo JText::_('ACY_DOWNLOAD'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.radiolist', $download, 'download' , 'size="1" onclick="updateTag();"', 'value', 'text', $pageInfo->download); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
					<?php echo JHTML::_('select.radiolist', $valImages, 'pict' , 'size="1" onclick="updateTag();"', 'value', 'text', '|pict:resized');?>
				</td>
			</tr>
		</table>
		<table>
			<tr>
				<td width="100%">
					<input placeholder="<?php echo JText::_('ACY_SEARCH'); ?>"  type="text" name="search" id="acymailingsearch" value="<?php echo $pageInfo->search;?>" class="text_area" onchange="document.adminForm.submit();" />
					<button class="btn" onclick="this.form.submit();"><?php echo JText::_( 'JOOMEXT_GO' ); ?></button>
					<button class="btn" onclick="document.getElementById('acymailingsearch').value='';this.form.submit();"><?php echo JText::_( 'JOOMEXT_RESET' ); ?></button>
				</td>
				<td nowrap="nowrap">
					<?php echo $this->_categories($pageInfo->filter_cat); ?>
				</td>
			</tr>
		</table>

		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
			<thead>
				<tr>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'FIELD_TITLE'), 'a.dmname', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_FILES'), 'a.dmfilename', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title">
						<?php echo JHTML::_('grid.sort', JText::_( 'TAG_CATEGORIES'), 'b.title', $pageInfo->filter->order->dir,$pageInfo->filter->order->value ); ?>
					</th>
					<th class="title titleid">
						<?php echo JHTML::_('grid.sort', JText::_( 'ACY_ID' ), 'a.id', $pageInfo->filter->order->dir, $pageInfo->filter->order->value ); ?>
					</th>
				</tr>
			</thead>
			<tfoot>
				<tr>
					<td colspan="5">
						<?php echo $pagination->getListFooter(); ?>
						<?php echo $pagination->getResultsCounter(); ?>
					</td>
				</tr>
			</tfoot>
			<tbody>
				<?php
					$k = 0;
					for($i = 0,$a = count($rows);$i<$a;$i++){
						$row =& $rows[$i];
				?>
					<tr id="content<?php echo $row->DocId; ?>" class="<?php echo "row$k"; ?>" onclick="applyContent(<?php echo $row->DocId.",'row$k'"?>);" style="cursor:pointer;">
						<td>
						<?php
							$text = '<b>'.JText::_('JOOMEXT_ALIAS').' : </b>'.$row->dmname;
							$text .= '<br /><b>'.JText::_('ACY_USERNAME',true).' : </b>'.$row->username;
							echo acymailing_tooltip($text, $row->dmdescription, '', $row->dmname);
						?>
						</td>
						<td>
							<?php if(strpos($row->dmfilename,': ')!= FALSE){
										$arti = str_replace('/','',strrchr(strip_tags($row->dmfilename),'/'));
										 echo $arti;
									}
									else{
										echo $row->dmfilename;
									}
							?>
						</td>
						<td>
						<?php
							if(!empty($row->title)){
								$text = '<b>'.JText::_('TAG_CATEGORIES',true).' : </b>'.$row->title;
								echo acymailing_tooltip($text, $row->title, '', $row->title);
							}
						?>
						</td>
						<td align="center" style="text-align:center" >
							<?php echo $row->DocId; ?>
						</td>
					</tr>
				<?php
						$k = 1-$k;
					}
				?>
			</tbody>
		</table>
		<input type="hidden" name="boxchecked" value="0" />
		<input type="hidden" name="filter_order" value="<?php echo $pageInfo->filter->order->value; ?>" />
		<input type="hidden" name="filter_order_Dir" value="<?php echo $pageInfo->filter->order->dir; ?>" />
	<?php

		echo $tabs->endPanel();
		echo $tabs->startPanel( JText::_('TAG_CATEGORIES'), 'docman_auto');
?>
		<br style="font-size:1px"/>
		<table width="100%" class="adminform">
			<tr>
				<td><?php echo JText::_('DISPLAY');?></td>
				<td colspan="3"><?php echo JHTML::_('select.radiolist', $contenttype, 'contenttypeauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autocontenttype); ?></td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('CLICKABLE_TITLE');?>
				</td>
				<td>
					<?php $titlelinkType = acymailing_get('type.titlelink'); $titlelinkType->onclick='updateTagAuto();'; echo $titlelinkType->display('autotitlelink',$pageInfo->autotitlelink);?>
				</td>
				<td>
				<?php echo JText::_('ACY_DOWNLOAD'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.radiolist', $download, 'downloadauto' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->downloadauto); ?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('DISPLAY_PICTURES');?>
				</td>
				<td colspan="3">
				<?php echo JHTML::_('select.radiolist', $valImages, 'autopict' , 'size="1" onclick="updateTagAuto();"', 'value', 'text', $pageInfo->autopict);?>
				</td>
			</tr>
			<tr>
				<td>
					<?php echo JText::_('MAX_ARTICLE'); ?>
				 </td>
				 <td>
				 	<input name="max_article" style="width:50px" value="<?php echo $pageInfo->automaxvalue; ?>" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('ACY_ORDER'); ?>
				 </td>
				 <td>
				 	<?php echo JHTML::_('select.genericlist', $ordering, 'contentorder' , 'size="1" onchange="updateTagAuto();"', 'value', 'text', $pageInfo->contentorder); ?>
				</td>
			</tr>
			<?php if($type == 'autonews') { ?>
			<tr>
				<td>
				<?php 	echo JText::_('MIN_ARTICLE'); ?>
				 </td>
				 <td>
				 <input name="min_article" style="width:50px" value="1" onchange="updateTagAuto();"/>
				</td>
				<td>
				<?php echo JText::_('JOOMEXT_FILTER'); ?>
				 </td>
				 <td>
				 	<?php $filter = acymailing_get('type.contentfilter'); $filter->onclick='updateTagAuto();'; echo $filter->display('contentfilter',$pageInfo->contentfilter); ?>
				</td>
			</tr>
			<?php } ?>
		</table>
		<table class="adminlist table table-striped table-hover" cellpadding="1" width="100%">
		<?php $k=0; foreach($this->catvalues as $oneCat){
			 if(empty($oneCat->value)) continue;
			?>
			<tr id="cat<?php echo $oneCat->value ?>" class="<?php echo "row$k"; ?>" onclick="applyAuto(<?php echo $oneCat->value ?>,'<?php echo "row$k" ?>');" style="cursor:pointer;">
				<td>
				<?php
					echo $oneCat->text;
				?>
				</td>
			</tr>
		<?php $k = 1 - $k; } ?>
		</table>
		<?php
		echo $tabs->endPanel();
		echo $tabs->endPane();
	 }

	function _categories($filter_cat){
		//select all cats
		$db = JFactory::getDBO();
		if(ACYMAILING_J16){
			$db->setQuery('SELECT id,parent_id,title FROM #__docman_categories ORDER BY `id` DESC');
		}else{
			$db->setQuery('SELECT id,parent_id,title FROM #__categories WHERE section = "com_docman" ORDER BY `id` DESC');
		}

		$mosetCats = $db->loadObjectList();
		$this->cats = array();
		foreach($mosetCats as $oneCat){
			$this->cats[$oneCat->parent_id][] = $oneCat;
		}

		$this->catvalues = array();
		$this->catvalues[] = JHTML::_('select.option', 0,JText::_('ACY_ALL'));
		$this->_handleChildrens();
		return JHTML::_('select.genericlist',   $this->catvalues, 'filter_cat', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', (int) $filter_cat);

	}

	function _handleChildrens($parent_id=0,$level=0){
		if(!empty($this->cats[$parent_id])){
			foreach($this->cats[$parent_id] as $cat){
				//$cat->name = str_repeat($this->separator,$level).$cat->cat_name;
				$this->catvalues[] = JHTML::_('select.option', $cat->id,str_repeat(" - - ",$level).$cat->title);
				$this->_handleChildrens($cat->id,$level+1);
			}
		}
	}


	 function acymailing_replacetags(&$email){
		$this->_replaceAuto($email);
 		$this->_replaceOne($email);
	 }

	 function _replaceOne(&$email){
		$match = '#{docman:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything...
		if(!$found) return;

		include_once(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_docman'.DS.'docman.class.php');
		$_DOCMAN = new dmMainFrame();
		include_once(ACYMAILING_ROOT.'administrator'.DS.'components'.DS.'com_docman'.DS.'classes'.DS.'DOCMAN_file.class.php');

		//We will need the mailer class as well
		$this->mailerHelper = acymailing_get('helper.mailer');

		$htmlreplace = array();
		$textreplace = array();
		$subjectreplace = array();
		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				//Don't need to process twice a tag we already have!
				if(isset($htmlreplace[$oneTag])) continue;

				$content = $this->_replaceContent($allresults,$i);
				$htmlreplace[$oneTag] = $content;
				$textreplace[$oneTag] = $this->mailerHelper->textVersion($content,true);
				$subjectreplace[$oneTag] = strip_tags($content);
			}
		}

		$email->body = str_replace(array_keys($htmlreplace),$htmlreplace,$email->body);
		$email->altbody = str_replace(array_keys($textreplace),$textreplace,$email->altbody);
		$email->subject = str_replace(array_keys($subjectreplace),$subjectreplace,$email->subject);
	 }

	 function _replaceContent(&$results,$i){

		//1 : Transform the tag properly...
		$arguments = explode('|',strip_tags($results[1][$i]));
		$tag = new stdClass();
		$tag->id = (int) $arguments[0];
		$tag->itemid = $this->params->get('ItemId');
		for($i=1,$a=count($arguments);$i<$a;$i++){
			$args = explode(':',$arguments[$i]);
			$args0 = trim($args[0]);
			if(isset($args[1])){
				$tag->$args0 = $args[1];
			}else{
				$tag->$args0 = true;
			}
		}

		//2 : Load the Joomla article... with the author, the section and the categories to create nice links
		$query = 'SELECT a.*,b.*,c.*,a.id as DocId FROM `#__docman` AS a ';
		if(ACYMAILING_J16){
			$query .= 'JOIN #__docman_categories AS b ON a.catid = b.id ';
		}else{
			$query .= 'JOIN #__categories AS b ON a.catid = b.id ';
		}
		$query .= 'LEFT JOIN `#__users` AS c ON a.dmsubmitedby = c.id ';
		$query .= 'WHERE a.id = '.$tag->id.' LIMIT 1';

		$db = JFactory::getDBO();
		$db->setQuery($query);
		$article = $db->loadObject();
		$result = '';

		//In case of we could not load the article for any reason...
		$app = JFactory::getApplication();
		if(empty($article)){
			if($app->isAdmin()){
				$app->enqueueMessage('The document "'.$tag->id.'" could not be loaded','notice');
			}
			return $result;
		}

		$link = 'index.php?option=com_docman&task=doc_details&gid='.$article->DocId;
		$linkdownload = 'index.php?option=com_docman&task=doc_download&gid='.$article->DocId;
		if(!empty($tag->itemid)){
			$link .= "&Itemid=".$tag->itemid;
			$linkdownload .= "&Itemid=".$tag->itemid;
		}
		$link = acymailing_frontendLink($link);
		$linkdownload = acymailing_frontendLink($linkdownload);

		//Add the title with a link or not on it.
		//If we add a link, we add in the same time a name="content-CONTENTID" so that we will be able to parse the content to create a nice summary

		$styleTitle = '<h2 class="acymailing_title">';
		$styleTitleEnd = '</h2>';

		$resultTitle = '';
		if(empty($tag->notitle)){
			if(!empty($tag->link)){
				$resultTitle = '<a href="'.$link.'" ';
				if($tag->type != "title") $resultTitle .= 'style="text-decoration:none" name="docman-'.$article->DocId.'" ';
				$resultTitle .= 'target="_blank" >'.$styleTitle.$article->dmname.$styleTitleEnd.'</a>';
			}else{
				$resultTitle = $styleTitle.$article->dmname.$styleTitleEnd;
			}
		}

		//We add the intro text

		if(!empty($tag->download)){
				$download = '<a style="text-decoration:none;" target="_blank" href="'.$linkdownload.'"><span class="acymailing_readmore">'.JText::_('ACY_DOWNLOAD').'</span></a>';

		}else{
			$download = '';
		}

		if($tag->type != "title"){

			if($tag->type == "intro"){
				if(!empty($article->dmthumbnail)){
					$result .= '<img src="images/stories/'.$article->dmthumbnail.'" style="float:left;margin:5px;" />';
				}
				if(!empty($article->dmdescription)){
					$result .= $article->dmdescription;
				}
			}
			else{
				$result .='<div>';
				if(!empty($article->dmthumbnail)){
					$result .= '<img src="images/stories/'.$article->dmthumbnail.'" style="float:left;margin:5px;" />';
				}
				if(!empty($article->dmdescription)){
					$result .= $article->dmdescription;
				}
				$result .= '</div><table  cellspacing="0" cellpadding="0" border="0" >';
					if(!empty($article->dmfilename)){
						if(strpos($article->dmfilename,': ')!= FALSE){
							$arti = str_replace('/','',strrchr($article->dmfilename,'/'));
						$result .= '<tr><td class="fieldname" >'.JText::_('ACY_FILES').' :</td><td class="fieldvalue" >'.$arti.'</td>';
							$result .= '<td class="fieldname" >'.JText::_('FIELD_SIZE').' :</td><td class="fieldvalue" >Link</td></tr>';
						}
						else{
							$result .= '<tr><td class="fieldname" >'.JText::_('ACY_FILES').' :</td><td class="fieldvalue" >'.$article->dmfilename.'</td>';
							$files = new DOCMAN_File($article->dmfilename,''.ACYMAILING_ROOT.'dmdocuments'.DS);
							$result .= '<td class="fieldname" >'.JText::_('FIELD_SIZE').' :</td><td class="fieldvalue" >'.$files->getSize().'</td></tr>';
						}
					}
					if(!empty($article->username)){
						$result .= '<tr><td class="fieldname" >'.JText::_('ACY_CREATED').' :</td><td class="fieldvalue" >'.$article->username.'</td>';
					}
					if(!empty($article->dmdate_published)){
						$result .= '<td class="fieldname" >'.JText::_('ACY_PUBLISHED').' :</td><td class="fieldvalue" >'.$article->dmdate_published.'</td></tr>';
					}
					$result .= "</table>";
			}

			$result = $resultTitle.$result.$download;
			$result = '<div class="acymailing_content">'.$result.'</div>';
		}else{
			$result = $resultTitle.$result.$download;
		}


		if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'docman.php')){
			ob_start();
			require(ACYMAILING_MEDIA.'plugins'.DS.'docman.php');
			$result = ob_get_clean();
		}

		if($this->params->get('removejs','yes') == 'yes'){
			$result = $this->_removeJS($result);

		}
		if(isset($tag->pict)){
			$pictureHelper = acymailing_get('helper.acypict');
			$pictureHelper->maxHeight = empty($tag->maxheight) ? $this->params->get('maxheight',150) : $tag->maxheight;
			$pictureHelper->maxWidth = empty($tag->maxwidth) ? $this->params->get('maxwidth',150) : $tag->maxwidth;
			if($tag->pict == '0'){
				$result = $pictureHelper->removePictures($result);
			}elseif($tag->pict == 'resized'){
				if($pictureHelper->available()){
					$result = $pictureHelper->resizePictures($result);
				}elseif($app->isAdmin()){
					$app->enqueueMessage($pictureHelper->error,'notice');
				}
			}
		}
		return $result;

	}

	function _replaceAuto(&$email){
		$this->acymailing_generateautonews($email);

		if(!empty($this->tags)){
			$email->body = str_replace(array_keys($this->tags),$this->tags,$email->body);
			if(!empty($email->altbody)) $email->altbody = str_replace(array_keys($this->tags),$this->tags,$email->altbody);
			foreach($this->tags as $tag => $result){
				$email->subject = str_replace($tag,strip_tags(preg_replace('#</tr>[^<]*<tr[^>]*>#Uis',' | ',$result)),$email->subject);
			}
		}
	}

	function acymailing_generateautonews(&$email){

		$return = new stdClass();
		$return->status = true;
		$return->message = '';

		$time = time();


		//Check if we should generate the SmartNewsletter or not...
		$match = '#{autodocman:(.*)}#Ui';
		$variables = array('subject','body','altbody');
		$found = false;
		foreach($variables as $var){
			if(empty($email->$var)) continue;
			$found = preg_match_all($match,$email->$var,$results[$var]) || $found;
			//we unset the results so that we won't handle it later... it will save some memory and processing
			if(empty($results[$var][0])) unset($results[$var]);
		}

		//If we didn't find anything... so we won't try to stop the generation
		if(!$found) return $return;

		$this->tags = array();
		$db = JFactory::getDBO();

		foreach($results as $var => $allresults){
			foreach($allresults[0] as $i => $oneTag){
				if(isset($this->tags[$oneTag])) continue;

				$arguments = explode('|',strip_tags($allresults[1][$i]));
				//The first argument is a list of sections and cats...
				$allcats = explode('-',$arguments[0]);
				$parameter = new stdClass();
				for($i=1;$i<count($arguments);$i++){
					$args = explode(':',$arguments[$i]);
					$arg0 = trim($args[0]);
					if(isset($args[1])){
						$parameter->$arg0 = $args[1];
					}else{
						$parameter->$arg0 = true;
					}
				}
				//Load the articles based on all arguments...
				$selectedArea = array();
				foreach($allcats as $oneCat){
					if(empty($oneCat)) continue;
					$selectedArea[] = (int) $oneCat;
				}

				$query = 'SELECT id FROM #__docman';
				$where = array();
				if(!empty($selectedArea)){
					$where[] = '`catid` IN ('.implode(',',$selectedArea).')';
				}

				if(!empty($parameter->filter) AND !empty($email->params['lastgenerateddate'])){
					$condition = '`dmdate_published` >\''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
					if($parameter->filter == 'modify'){
						$condition .= ' OR `dmlastupdateon` > \''.date( 'Y-m-d H:i:s',$email->params['lastgenerateddate'] - date('Z')).'\'';
					}

					$where[] = $condition;
				}

				if(!ACYMAILING_J16){
					if(isset($parameter->access)){
						$where[] = 'access <= '.intval($parameter->access);
					}else{
						if($this->params->get('contentaccess','registered') == 'registered') $where[] = 'access <= 1';
						elseif($this->params->get('contentaccess','registered') == 'public') $where[] = 'access = 0';
					}
				}elseif(isset($parameter->access)){
					//We set it only if the access is defined in the tag
					$where[] = 'access = '.intval($parameter->access);
				}

				$where[] = "published = 1";
				$where[] = "approved = 1";


				$query .= ' WHERE ('.implode(') AND (',$where).')';
				if(!empty($parameter->order)){
					if($parameter->order == 'rand'){
						$query .= ' ORDER BY rand()';
					}else{
						$ordering = explode(',',$parameter->order);
						$query .= ' ORDER BY `'.acymailing_secureField(trim($ordering[0])).'` '.acymailing_secureField(trim($ordering[1]));
					}
				}
				if(!empty($parameter->max)) $query .= ' LIMIT '.(int) $parameter->max;
				elseif(empty($email->params['lastgenerateddate'])) $query .= ' LIMIT 20';
				//We add a limit for the preview otherwise we could break everything

				$db->setQuery($query);
				$allArticles = acymailing_loadResultArray($db);

				if(!empty($parameter->min) AND count($allArticles)< $parameter->min){
					//We won't generate the Newsletter
					$return->status = false;
					$return->message = 'Not enough Docman content for the tag '.$oneTag.' : '.count($allArticles).' / '.$parameter->min.' between '.acymailing_getDate($email->params['lastgenerateddate']).' and '.acymailing_getDate($time);
				}

				$stringTag = '';
				if(!empty($allArticles)){
					if(file_exists(ACYMAILING_MEDIA.'plugins'.DS.'autodocman.php')){
						ob_start();
						require(ACYMAILING_MEDIA.'plugins'.DS.'autodocman.php');
						$stringTag = ob_get_clean();
					}else{
						//we insert the article tag one after the other in a table as they are already sorted
						$stringTag .= '<table cellspacing="0" cellpadding="0" border="0">';
						foreach($allArticles as $oneArticleId){
							$stringTag .= '<tr><td>';
							$args = array();
							$args[] = 'docman:'.$oneArticleId;
							if(!empty($parameter->type)) $args[] = 'type:'.$parameter->type;
							if(!empty($parameter->link)) $args[] = 'link';
							if(!empty($parameter->download)) $args[] = 'download';
							if(!empty($parameter->lang)) $args[] = 'lang:'.$parameter->lang;
							if(!empty($parameter->notitle)) $args[] = 'notitle';
							if(!empty($parameter->created)) $args[] = 'created';
							if(!empty($parameter->noreadmore)) $args[] = 'noreadmore';
							if(isset($parameter->pict)) $args[] = 'pict:'.$parameter->pict;
							if(!empty($parameter->wrap)) $args[] = 'wrap:'.$parameter->wrap;
							if(!empty($parameter->maxwidth)) $args[] = 'maxwidth:'.$parameter->maxwidth;
							if(!empty($parameter->maxheight)) $args[] = 'maxheight:'.$parameter->maxheight;
							if(!empty($parameter->readmore)) $args[] = 'readmore:'.$parameter->readmore;
							$stringTag .= '{'.implode('|',$args).'}';
							$stringTag .= '</td></tr>';
						}
						$stringTag .= '</table>';
					}
				}

				$this->tags[$oneTag] = $stringTag;
			}
		}

		return $return;
	}

	function _removeJS($text){
		//Remove the picture... normal process
		$text = preg_replace("#(onmouseout|onmouseover|onclick|onfocus|onload|onblur) *= *\"(?:(?!\").)*\"#iU",'',$text);
		$text =  preg_replace("#< *script(?:(?!< */ *script *>).)*< */ *script *>#isU",'',$text);
		return $text;
	}


	 function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;

		$type['docman_groups'] ='Docman Groups';

		$db = JFactory::getDBO();
		$db->setQuery("SELECT `groups_id`,`groups_name` FROM `#__docman_groups` ORDER BY `groups_name` ASC");
		$groups = $db->loadObjectList();
		$groupsin = acymailing_get('type.operatorsin');
		$groupsin->js = 'onchange="countresults(__num__)"';

		$return = '<div id="filter__num__docman_groups">'.$groupsin->display("filter[__num__][docman_groups][type]");
		$return.= ' '.JHTML::_('select.genericlist',   $groups, "filter[__num__][docman_groups][group]", 'class="inputbox" size="1"', 'groups_id', 'groups_name').'</div>';

	 	return $return;
	 }
	 function onAcyProcessFilterCount_docman_groups(&$query,$filter,$num){
		$db = JFactory::getDBO();
		$db->setQuery('SELECT groups_members FROM `#__docman_groups` WHERE `groups_id` = '.intval($filter['group']));
		$allIds  = $db->loadResult();
		if(empty($allIds)) $allIds = '-1';
		$operator = ($filter['type'] == 'IN') ? 'IN' : "NOT IN";
		$query2 = 'SELECT count(sub.subid) FROM #__acymailing_subscriber as sub ' .
					'WHERE (sub.userid '.$operator.' ('.$allIds.'))';
		$db->setQuery($query2);
		$count = $db->loadResult();
		return JText::sprintf('SELECTED_USERS',$count);
	 }
	 function onAcyProcessFilter_docman_groups(&$query,$filter,$num){
	 	//We get the e-mail of the users which belong to this group, it's much easier that way
		$query->db->setQuery('SELECT groups_members FROM `#__docman_groups` WHERE `groups_id` = '.intval($filter['group']));
		$allIds  = $query->db->loadResult();
		if(empty($allIds)) $allIds = '-1';
		$operator = ($filter['type'] == 'IN') ? 'IN' : "NOT IN";
		$query->where[] = "sub.userid $operator (".$allIds.")";
	 }

}//endclass